Require Import List Arith.
Require Import Prelude Permission GenericTrace.
Require Import Trace.

Module Make (Perm : Permission)
            ( Export Address: DecidableInfiniteSet) 
            ( Export T : Type_.TYPE Address )
            ( Export V : Value.TYPE Address T ) (Tr : TraceT Perm Address T V).

  Import Tr.

  Hint Constructors singleAction.

  Lemma eq_action_dec : 
    forall (a a' : action), {a = a'} + {a <> a'}.
  Proof.  
    repeat decide equality; 
    try ( apply Perm.eq_dec || apply Address.eq_dec || apply V.eq_dec).
  Qed.
  
  Lemma open_action_dec  : 
    forall (a : action), (exists p, a = Open p) \/ (forall p, a <> Open p).
  Proof.
    destruct a; solve [ left; eauto | right; intuition discriminate].
  Qed.
  
  Lemma singleAction_dec : forall a, {singleAction a} + { ~ singleAction a}.
  Proof.
    destruct a; solve [auto | right; intro Ha; inversion Ha].
  Qed.
    
End Make.

Module Type Proj 
       (Perm : Permission) 
       ( Export Address: DecidableInfiniteSet) 
       ( Export T : Type_.TYPE Address )
       ( Export V : Value.TYPE Address T ) (TT : TraceT Perm Address T V).
  Include Make Perm Address T V TT.
End Proj.